const state = require('../state');
const {createUIEvent, createFocusEvent} = require('../event');
const {focusable} = require('../util').element;

state.register('page', {
	focusElement: null,
	uploadingInputElement: null,
	currentElement: document.documentElement
});

exports.setFocusElement = function () {
	const element = state.get('page').currentElement;

	if (element === this.focusElement) {
		return;
	}

	const oldFocusElement = this.focusElement;
	oldFocusElement && oldFocusElement.dispatchEvent(createFocusEvent('focusout'));
		
	state.update('page', clone => {
		clone.focusElement = element && focusable(element) ? element: null;
	});

	this.focusElement && this.focusElement.dispatchEvent(createFocusEvent('focusin'));
	oldFocusElement && oldFocusElement.dispatchEvent(createUIEvent('blur'));
	this.focusElement && this.focusElement.dispatchEvent(createUIEvent('focus'));
};

exports.dispatchEvent = function (event) {
	if (!(event instanceof Event)) {
		throw new Error('Can not dispatch a non-event object');
	}
	
	state.get('page').currentElement.dispatchEvent(event);
	
	return true;
};